/*******************************************************************************
 *
 * File Name: ANNexperienceClass.cpp
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN)
 * Project Version: 1l3j 2-Sept-08
 * Comments:
 *
 *******************************************************************************/

#include "ANNexperienceClass.h"


#include <ctime>
#include <cstdlib>	//for random number generation
#include <cmath>

#include <string>
#include <iostream>
#include <fstream>
using namespace std;







Experience::Experience(void)
{
	classTargetValue = 0;
	firstExperienceInput = new ExperienceInput();
	next = NULL;
}

Experience::~Experience(void)
{
	if(firstExperienceInput != NULL)
	{
		delete firstExperienceInput;
	}
	
	if(next != NULL)
	{
		delete next;
	}
	
}



ExperienceInput::ExperienceInput(void)
{
	inputValue = 0;
	next = NULL;
}

ExperienceInput::~ExperienceInput(void)
{
	if(next != NULL)
	{
		delete next;
	}
}


Experience * findExperience(Experience * firstExperienceInDataSet, long experienceNumToFind)
{
	Experience * foundExperience;
	Experience * currentExperience = firstExperienceInDataSet;
	for(long i = 0; i < experienceNumToFind; i++)
	{
		currentExperience = currentExperience->next;
	}
	foundExperience = currentExperience;
	return foundExperience;
}

long countNumberOfExperienceInputs(Experience * experience)
{
	long numberOfExperienceInputs = 0;

	ExperienceInput * currentExperienceInput = experience->firstExperienceInput;
	while(currentExperienceInput->next != NULL)
	{
		numberOfExperienceInputs++;
		currentExperienceInput = currentExperienceInput->next;
	}

	return numberOfExperienceInputs;
}

long countNumberOfExperiences(Experience * firstExperienceInList)
{
	long numberOfExperiences = 0;

	Experience * currentExperience = firstExperienceInList;
	while(currentExperience->next != NULL)
	{
		numberOfExperiences++;
		currentExperience = currentExperience->next;
	}

	return numberOfExperiences;
}
