/*******************************************************************************
 *
 * File Name: ANNsprite.cpp
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 1l3j 2-Sept-08
 *
 *******************************************************************************/

/*This code allows the addition of a sprite into a given scene file where a sprite is a paragraph of text. [The text is to be rendered in 3D, and point towards the user POV - see CHECK THIS for missing code]*/



#include "ANNsprite.h"
#include "math.h"
#include "LDreferenceManipulation.h"
#include "LDvector.h"
#include "XMLrulesClass.h"


/*old;
#define SPRITE_EXTENSION ".ldr"
#define SPRITE_NAME_END (SPRITE_EXTENSION)
*/

#define CHAR_PLUS ('+')
#define CHAR_MINUS ('-')
#define CHAR_EQUALS ('=')
#define CHAR_FULLSTOP ('.')

#define DEFAULT_LDRAW_SUBMODEL_COLOUR (16)


static string SPRITE_SUBMODEL_NEURON_FILE_NAME;
static int SPRITE_TEXTUAL_INCLUDE_NEURON_ID_COLOUR;
static int SPRITE_TEXTUAL_INCLUDE_NEURON_ORDERID_COLOUR;
static int SPRITE_TEXTUAL_INCLUDE_NEURON_LAYERID_COLOUR;
static int SPRITE_TEXTUAL_INCLUDE_NEURON_SUBNETID_COLOUR;
static int SPRITE_TEXTUAL_INCLUDE_NEURON_BIAS_COLOUR;
static int SPRITE_TEXTUAL_INCLUDE_NEURON_OUTPUT_COLOUR;
static int SPRITE_TEXTUAL_INCLUDE_NEURON_CLASSTARGET_COLOUR;
static int SPRITE_TEXTUAL_INCLUDE_NEURON_ERROR_COLOUR;
static int SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_COLOUR;
static double SPRITE_SUBMODEL_RANGE_SCALE_FACTOR;

static int SPRITE_DEFAULT_COLOUR;

static double SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO;
static double SPRITE_TEXT_SCALE_FACTOR;
static double SPRITE_TEXT_DICE_SCALE_FACTOR;
static double SPRITE_CHAR_HEIGHT_IN_PIXELS;
static double SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT;

	static double SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS;			//derivable
	static double SPRITE_LINE_SPACING_RATIO;						//derivable
	static double SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS;			//derivable

static double SPRITE_CHAR_WIDTH_IN_PIXELS;
static double SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS;
static double SPRITE_DICE_WIDTH_IN_LDRAW_UNITS;
static double SPRITE_CHAR_SPACING_RATIO;

	static double SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS;			//derivable
	static double SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS;		//derivable
	static double SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS;			//derivable
	static double SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS;	//derivable
	static double SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS;			//derivable

static double SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS;
static double SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS;

static double SPRITE_TEXT_DICE_Y_OFFSET;

static string SPRITE_NAME_START;
static string SPRITE_EXTENSION;
static string SPRITE_CHARACTER_START;
static string SPRITE_CHARACTER_EXTENSION;

bool SPRITE_TEXTUAL_INCLUDE_NEURON_ID_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURON_ORDERID_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURON_LAYERID_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURON_SUBNETID_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURON_BIAS_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURON_OUTPUT_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURON_CLASSTARGET_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURON_ERROR_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_INFO;

bool SPRITE_TEXTUAL_INCLUDE_NEURON_EXTRA_SECONDARY_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_INFO;
bool SPRITE_TEXTUAL_INCLUDE_NEURON_INFO;
bool SPRITE_TEXTUAL_INCLUDE_INFO;

void fillInANNSpriteExternVariables()
{
	RulesClass * currentReferenceRulesClass = ANNrulesSprite;

	while(currentReferenceRulesClass->next != NULL)
	{
		if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_NEURON_FILE_NAME_NAME)
		{
			SPRITE_SUBMODEL_NEURON_FILE_NAME = currentReferenceRulesClass->stringValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_ID_COLOUR_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_ID_COLOUR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_ORDERID_COLOUR_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_ORDERID_COLOUR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_LAYERID_COLOUR_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_LAYERID_COLOUR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_SUBNETID_COLOUR_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_SUBNETID_COLOUR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_BIAS_COLOUR_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_BIAS_COLOUR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_OUTPUT_COLOUR_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_OUTPUT_COLOUR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_CLASSTARGET_COLOUR_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_CLASSTARGET_COLOUR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_ERROR_COLOUR_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_ERROR_COLOUR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_COLOUR_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_COLOUR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SUBMODEL_RANGE_SCALE_FACTOR_NAME)
		{
			SPRITE_SUBMODEL_RANGE_SCALE_FACTOR = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITE_DEFAULT_COLOUR_NAME)
		{
			SPRITE_DEFAULT_COLOUR = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO_NAME)
		{
			SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXT_SCALE_FACTOR_NAME)
		{
			SPRITE_TEXT_SCALE_FACTOR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXT_DICE_SCALE_FACTOR_NAME)
		{
			SPRITE_TEXT_DICE_SCALE_FACTOR = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_CHAR_HEIGHT_IN_PIXELS_NAME)
		{
			SPRITE_CHAR_HEIGHT_IN_PIXELS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT_NAME)
		{
			SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITE_CHAR_WIDTH_IN_PIXELS_NAME)
		{
			SPRITE_CHAR_WIDTH_IN_PIXELS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS_NAME)
		{
			SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS  = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_DICE_WIDTH_IN_LDRAW_UNITS_NAME)
		{
			SPRITE_DICE_WIDTH_IN_LDRAW_UNITS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_CHAR_SPACING_RATIO_NAME)
		{
			SPRITE_CHAR_SPACING_RATIO = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS_NAME)
		{
			SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS = currentReferenceRulesClass->fractionalValue;
		}
		else if(currentReferenceRulesClass->name == SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS_NAME)
		{
			SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS = currentReferenceRulesClass->fractionalValue;
		}

		else if(currentReferenceRulesClass->name == SPRITE_TEXT_DICE_Y_OFFSET_NAME)
		{
			SPRITE_TEXT_DICE_Y_OFFSET = currentReferenceRulesClass->fractionalValue;
		}


		else if(currentReferenceRulesClass->name == SPRITE_NAME_START_NAME)
		{
			SPRITE_NAME_START = currentReferenceRulesClass->stringValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_EXTENSION_NAME)
		{
			SPRITE_EXTENSION = currentReferenceRulesClass->stringValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_CHARACTER_START_NAME)
		{
			SPRITE_CHARACTER_START = currentReferenceRulesClass->stringValue;
		}
		else if(currentReferenceRulesClass->name == SPRITE_CHARACTER_EXTENSION_NAME)
		{
			SPRITE_CHARACTER_EXTENSION = currentReferenceRulesClass->stringValue;
		}

		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_ID_INFO_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_ID_INFO = (bool)((int)(currentReferenceRulesClass->fractionalValue));
			//cout << "SPRITE_TEXTUAL_INCLUDE_NEURON_ID_INFO = " << SPRITE_TEXTUAL_INCLUDE_NEURON_ID_INFO << endl;
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_ORDERID_INFO_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_ORDERID_INFO = (bool)((int)(currentReferenceRulesClass->fractionalValue));
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_LAYERID_INFO_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_LAYERID_INFO = (bool)((int)(currentReferenceRulesClass->fractionalValue));
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_SUBNETID_INFO_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_SUBNETID_INFO = (bool)((int)(currentReferenceRulesClass->fractionalValue));
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_BIAS_INFO_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_BIAS_INFO = (bool)((int)(currentReferenceRulesClass->fractionalValue));
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_OUTPUT_INFO_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_OUTPUT_INFO = (bool)((int)(currentReferenceRulesClass->fractionalValue));
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_CLASSTARGET_INFO_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_CLASSTARGET_INFO = (bool)((int)(currentReferenceRulesClass->fractionalValue));
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURON_ERROR_INFO_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURON_ERROR_INFO = (bool)((int)(currentReferenceRulesClass->fractionalValue));
		}
		else if(currentReferenceRulesClass->name == SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_INFO_NAME)
		{
			SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_INFO = (bool)((int)(currentReferenceRulesClass->fractionalValue));
		}

		else
		{

		}


		currentReferenceRulesClass = currentReferenceRulesClass->next;
	}

	SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS = (SPRITE_CHAR_HEIGHT_IN_PIXELS * SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO);
	SPRITE_LINE_SPACING_RATIO = (SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT * SPRITE_TEXT_SCALE_FACTOR);	//OLD: SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT/(SPRITE_TEXT_SCALE_FACTOR/4), //NB '/(SPRITE_TEXT_SCALE_FACTOR/4)' is due to dice size. without dice present SPRITE_LINE_SPACING_RATIO = (1.5);
	SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS = ((SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS*SPRITE_LINE_SPACING_RATIO)*SPRITE_TEXT_SCALE_FACTOR);

	SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS = (SPRITE_CHAR_WIDTH_IN_PIXELS * SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO);
	SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS = (SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS * SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO);
	SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS = ((SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS * SPRITE_CHAR_SPACING_RATIO)*SPRITE_TEXT_SCALE_FACTOR);
	SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS = ((SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS * SPRITE_CHAR_SPACING_RATIO)*SPRITE_TEXT_SCALE_FACTOR);
	SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS = ((SPRITE_DICE_WIDTH_IN_LDRAW_UNITS * SPRITE_CHAR_SPACING_RATIO)*SPRITE_TEXT_DICE_SCALE_FACTOR);


	SPRITE_TEXTUAL_INCLUDE_NEURON_EXTRA_SECONDARY_INFO = false;

	if(SPRITE_TEXTUAL_INCLUDE_NEURON_ORDERID_INFO || SPRITE_TEXTUAL_INCLUDE_NEURON_LAYERID_INFO || SPRITE_TEXTUAL_INCLUDE_NEURON_SUBNETID_INFO || SPRITE_TEXTUAL_INCLUDE_NEURON_BIAS_INFO || SPRITE_TEXTUAL_INCLUDE_NEURON_OUTPUT_INFO || SPRITE_TEXTUAL_INCLUDE_NEURON_CLASSTARGET_INFO || SPRITE_TEXTUAL_INCLUDE_NEURON_ERROR_INFO)
	{
		SPRITE_TEXTUAL_INCLUDE_NEURON_EXTRA_SECONDARY_INFO = true;
	}

	if(SPRITE_TEXTUAL_INCLUDE_NEURON_ID_INFO || SPRITE_TEXTUAL_INCLUDE_NEURON_EXTRA_SECONDARY_INFO)
	{
		SPRITE_TEXTUAL_INCLUDE_NEURON_INFO = true;
	}
	else
	{
		SPRITE_TEXTUAL_INCLUDE_NEURON_INFO = false;
	}

	if(SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_INFO)
	{
		SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_INFO = true;
	}
	else
	{
		SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_INFO = false;
	}
	if(SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_INFO || SPRITE_TEXTUAL_INCLUDE_NEURON_INFO)
	{
		SPRITE_TEXTUAL_INCLUDE_INFO = true;
	}
	else
	{
		SPRITE_TEXTUAL_INCLUDE_INFO = false;
	}

	/*
	cout << "SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS = " << SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_LINE_SPACING_RATIO = " << SPRITE_LINE_SPACING_RATIO << endl;
	cout << "SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS = " << SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS << endl;

	cout << "SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS = " << SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS = " << SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS = " << SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS = " << SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS << endl;
	cout << "SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS = " << SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS << endl;
	*/




}


/*top level sprite routines - required for independent LRRCsprite.cpp calculations*/


bool ANNcreateNeuralNetworkSceneFilesWithAndWithoutSprites(char* sceneFileNameWithoutSprites, char* sceneFileNameWithSprites, NeuronContainer * firstNeuronInNetwork)
{
	bool result = true;

	if(!parseANNRulesXMLFile())
	{
		result = false;
	}
	fillInANNSpriteExternVariables();

	int numSpritesAdded = 0;
	int numnonSpritesAdded = 0;
	vec eyeCoords;
	eyeCoords.x = 0.0;
	eyeCoords.y = 0.0;
	eyeCoords.z = 0.0;

	Reference * nonspriteListInitialReference = new Reference();
	Reference * spriteListInitialReference = new Reference();

	//searchNeuralNetworkAndCreateNonSpriteReferences(firstNeuronInNetwork, nonspriteListInitialReference, &eyeCoords, &numnonSpritesAdded, sceneFileNameWithSprites);
	//searchNeuralNetworkAndCreateSpriteReferences(firstNeuronInNetwork, spriteListInitialReference, &eyeCoords, &numSpritesAdded, sceneFileNameWithSprites);

/*
	vec subnetPosition;
	subnetPosition.x = 0.0;
	subnetPosition.y = 0.0;
	subnetPosition.z = 0.0;
*/
	ANNsearchNeuralNetworkAndCreateSpriteAndNonSpriteReferences(firstNeuronInNetwork, spriteListInitialReference, nonspriteListInitialReference, &eyeCoords, &numSpritesAdded, &numnonSpritesAdded, sceneFileNameWithSprites, false, NULL);

	//cout << "DEBUG: qqstart" << endl;


	//cout << "DEBUG: qqend" << endl;

	/*
	nonspriteListByteArray[nonspriteListByteArraySize] = '\n';
	nonspriteListByteArraySize++;
	*/


	writeReferencesToFile(sceneFileNameWithoutSprites, nonspriteListInitialReference);

	if(SPRITE_TEXTUAL_INCLUDE_INFO)
	{
		if(!addSpriteReferenceListToSceneFile(sceneFileNameWithoutSprites, sceneFileNameWithSprites, spriteListInitialReference, numSpritesAdded))
		{
			result = false;
		}
	}

	delete nonspriteListInitialReference;
	delete spriteListInitialReference;
	
	return result;
}


//void searchNeuralNetworkAndCreateNonSpriteReferences(NeuronContainer * firstNeuronContainerInLayer, Reference * nonspriteListInitialReference, vec * eyeCoords, int * numnonSpritesAdded, char* sceneFileNameWithSprites)
Reference * ANNsearchNeuralNetworkAndCreateSpriteAndNonSpriteReferences(NeuronContainer * firstNeuronContainerInLayer, Reference * spriteListInitialReference, Reference * currentNonSpriteListReference, vec * eyeCoords, int * numSpritesAdded, int * numnonSpritesAdded, char* sceneFileNameWithSprites, bool isSubnet, vec * positionOfSubnetNeuron)
{
	//cout << "here03" << endl;

	Reference * updatedNonSpriteListReference = currentNonSpriteListReference;

	bool result = true;

	NeuronContainer * currentNeuron = firstNeuronContainerInLayer;
	while(currentNeuron->nextNeuronContainer != NULL)
	{
		ANNfillNeuronDisplayReference(updatedNonSpriteListReference, currentNeuron->neuron, isSubnet, positionOfSubnetNeuron);
		Reference * currentNeuronReferenceOnLayer = updatedNonSpriteListReference;

		if(SPRITE_TEXTUAL_INCLUDE_NEURON_INFO)
		{
			if(!ANNdetermineSpriteInfoForNeuronAndAddSpriteToSpriteRefList(updatedNonSpriteListReference, currentNeuron, spriteListInitialReference, eyeCoords, numSpritesAdded, sceneFileNameWithSprites))
			{
				result = false;
			}
		}

		Reference * newNeuronDispayReference = new Reference();
		updatedNonSpriteListReference->next = newNeuronDispayReference;
		updatedNonSpriteListReference = updatedNonSpriteListReference->next;


		if(currentNeuron->hasBackLayer == true)
		{

			NeuronConnectionContainer * currentNeuronConnectionContainerInBackLayer = currentNeuron->firstBackNeuronConnectionContainer;
			while(currentNeuronConnectionContainerInBackLayer -> nextNeuronConnectionContainer != NULL)
			{
				//regenerate reference properties for a neuron display reference in the previous layer (which is connected to the current neuron)

				Reference currentNeuronReferenceOnPreviousLayer;
				ANNfillNeuronDisplayReference(&currentNeuronReferenceOnPreviousLayer, currentNeuronConnectionContainerInBackLayer->neuron, isSubnet, positionOfSubnetNeuron);

				if(!ANNfillNeuronConnectionDisplayReference(updatedNonSpriteListReference, &currentNeuronReferenceOnPreviousLayer, currentNeuronReferenceOnLayer, currentNeuronConnectionContainerInBackLayer->neuronConnection))
				{
					result = false;
				}

				if(SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_INFO)
				{
					if(!ANNdetermineSpriteInfoForNeuronConnectionAndAddSpriteToSpriteRefList(updatedNonSpriteListReference, currentNeuronConnectionContainerInBackLayer, spriteListInitialReference, eyeCoords, numSpritesAdded, sceneFileNameWithSprites, &currentNeuronReferenceOnPreviousLayer, currentNeuronReferenceOnLayer))
					{
						result = false;
					}
				}

				Reference * newNeuronDispayReference = new Reference();
				updatedNonSpriteListReference->next = newNeuronDispayReference;
				updatedNonSpriteListReference = updatedNonSpriteListReference->next;


				currentNeuronConnectionContainerInBackLayer = currentNeuronConnectionContainerInBackLayer -> nextNeuronConnectionContainer;
			}
		}



	#ifdef ANN
		if(currentNeuron->isSubnet)
		{
			//create back layer of subnet 1-1 connections for display only
			NeuronContainer * currentNeuronContainerInBackLayerOfSubnet = currentNeuron->firstNeuronContainerInBackLayerOfSubnet;
			NeuronConnectionContainer * currentNeuronConnectionContainerInBackLayer = currentNeuron->firstBackNeuronConnectionContainer;
			while(currentNeuronConnectionContainerInBackLayer -> nextNeuronConnectionContainer != NULL)
			{
				//regenerate reference properties for a neuron display reference in the previous layer (which is connected to the current neuron)

				Reference currentNeuronReferenceOnPreviousLayer;
				ANNfillNeuronDisplayReference(&currentNeuronReferenceOnPreviousLayer, currentNeuronConnectionContainerInBackLayer->neuron, isSubnet, positionOfSubnetNeuron);

				Reference currentNeuronReferenceOnBackLayerOfSubnet;
				ANNfillNeuronDisplayReference(&currentNeuronReferenceOnBackLayerOfSubnet, currentNeuronContainerInBackLayerOfSubnet->neuron, true, &(currentNeuronReferenceOnLayer->relativePosition));

				NeuronConnection blankOneToOneNeuronConnection;
				blankOneToOneNeuronConnection.weight = 0.0;
				if(!ANNfillNeuronConnectionDisplayReference(updatedNonSpriteListReference, &currentNeuronReferenceOnBackLayerOfSubnet, &currentNeuronReferenceOnPreviousLayer, &blankOneToOneNeuronConnection))
				{
					result = false;
				}

				Reference * newNeuronDispayReference = new Reference();
				updatedNonSpriteListReference->next = newNeuronDispayReference;
				updatedNonSpriteListReference = updatedNonSpriteListReference->next;

				currentNeuronContainerInBackLayerOfSubnet=currentNeuronContainerInBackLayerOfSubnet->nextNeuronContainer;
				currentNeuronConnectionContainerInBackLayer = currentNeuronConnectionContainerInBackLayer -> nextNeuronConnectionContainer;
			}

			//create front layer of subnet 1-1 connections for display only
			NeuronContainer * currentNeuronContainerInFrontLayerOfSubnet = currentNeuron->firstNeuronContainerInFrontLayerOfSubnet;
			NeuronConnectionContainer * currentNeuronConnectionContainerInFrontLayer = currentNeuron->firstFrontNeuronConnectionContainer;
			while(currentNeuronConnectionContainerInFrontLayer -> nextNeuronConnectionContainer != NULL)
			{
				//regenerate reference properties for a neuron display reference in the previous layer (which is connected to the current neuron)

				Reference currentNeuronReferenceOnNextLayer;
				ANNfillNeuronDisplayReference(&currentNeuronReferenceOnNextLayer, currentNeuronConnectionContainerInFrontLayer->neuron, isSubnet, positionOfSubnetNeuron);

				Reference currentNeuronReferenceOnFrontLayerOfSubnet;
				ANNfillNeuronDisplayReference(&currentNeuronReferenceOnFrontLayerOfSubnet, currentNeuronContainerInFrontLayerOfSubnet->neuron, true, &(currentNeuronReferenceOnLayer->relativePosition));

				NeuronConnection blankOneToOneNeuronConnection;
				blankOneToOneNeuronConnection.weight = 0.0;
				if(!ANNfillNeuronConnectionDisplayReference(updatedNonSpriteListReference, &currentNeuronReferenceOnFrontLayerOfSubnet, &currentNeuronReferenceOnNextLayer, &blankOneToOneNeuronConnection))
				{
					result = false;
				}

				Reference * newNeuronDispayReference = new Reference();
				updatedNonSpriteListReference->next = newNeuronDispayReference;
				updatedNonSpriteListReference = updatedNonSpriteListReference->next;

				currentNeuronContainerInFrontLayerOfSubnet=currentNeuronContainerInFrontLayerOfSubnet->nextNeuronContainer;
				currentNeuronConnectionContainerInFrontLayer = currentNeuronConnectionContainerInFrontLayer -> nextNeuronConnectionContainer;
			}

			//cout << "here" << endl;

			updatedNonSpriteListReference = ANNsearchNeuralNetworkAndCreateSpriteAndNonSpriteReferences(currentNeuron->firstNeuronContainerInBackLayerOfSubnet, spriteListInitialReference, updatedNonSpriteListReference, eyeCoords, numSpritesAdded, numnonSpritesAdded, sceneFileNameWithSprites, (true|isSubnet), &(currentNeuronReferenceOnLayer->relativePosition));
		}
	#endif


		currentNeuron = currentNeuron -> nextNeuronContainer;
	}
	if(firstNeuronContainerInLayer->hasFrontLayer)
	{
		updatedNonSpriteListReference = ANNsearchNeuralNetworkAndCreateSpriteAndNonSpriteReferences(firstNeuronContainerInLayer->firstNeuronInFrontLayer, spriteListInitialReference, updatedNonSpriteListReference, eyeCoords, numSpritesAdded, numnonSpritesAdded, sceneFileNameWithSprites, isSubnet, positionOfSubnetNeuron);
	}

	return updatedNonSpriteListReference;

}













































/*medium level sprite routines - these can be used by LRRCsprite.cpp top level routines or by LRRCgame.cpp routines*/

bool ANNfillNeuronDisplayReference(Reference * currentNeuronDispayReference, Neuron * neuron, bool hasSubnetNeuron, vec * positionOfsubnetNeuron)
{
	bool result = true;





	mat currentDeformationMatrix;

	//add neuron range info [green ring/sphere/cylinder]
	//cout << "vv1" << endl;

	createIdentityMatrix(&currentDeformationMatrix);
	scaleMatrix(&currentDeformationMatrix, (0.005/((neuron->subnetID)*2.0)*(SPRITE_SUBMODEL_RANGE_SCALE_FACTOR*LDRAW_UNITS_PER_CM)));		//	scaleMatrix(&currentDeformationMatrix, ((neuronContainer->neuron->bias)*(SPRITE_SUBMODEL_RANGE_SCALE_FACTOR*LDRAW_UNITS_PER_CM)));
	copyMatrix2IntoMatrix1(&(currentNeuronDispayReference->deformationMatrix), &(currentDeformationMatrix));




	currentNeuronDispayReference->type = REFERENCE_TYPE_SUBMODEL;



	if(neuron->bias < (-3.0))
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_MAGENTA;
	}
	else if(neuron->bias < (-0.8))
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_RED;
	}
	else if(neuron->bias < -0.4)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_ORANGE;
	}
	else if(neuron->bias < -0.01)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_YELLOW;
	}
	else if(neuron->bias < 0.01)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_DARKGREY;
	}
	else if(neuron->bias < 0.4)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_GREEN;
	}
	else if(neuron->bias < 0.8)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_CYAN;
	}
	else if(neuron->bias < 3.0)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_BLUE;
	}
	else
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_PURPLE;
	}

	if(hasSubnetNeuron)
	{
		currentNeuronDispayReference->relativePosition.x = (positionOfsubnetNeuron->x) + (double)(neuron->orderID)/((double)(neuron->subnetID)*3.0);
		currentNeuronDispayReference->relativePosition.y = (positionOfsubnetNeuron->y) + (double)(neuron->layerID)/((double)(neuron->subnetID)*3.0);
		currentNeuronDispayReference->relativePosition.z = (positionOfsubnetNeuron->z) + (double)(neuron->subnetID)/(4.0);
	}
	else
	{
		if(neuron->spatialCoordinatesSet)
		{
			currentNeuronDispayReference->relativePosition.x = (double)(neuron->xPosRel);
			currentNeuronDispayReference->relativePosition.y = (double)(neuron->layerID);
			currentNeuronDispayReference->relativePosition.z = (double)(neuron->yPosRel);
		}
		else
		{
			currentNeuronDispayReference->relativePosition.x = (double)(neuron->orderID);
			currentNeuronDispayReference->relativePosition.y = (double)(neuron->layerID);
			currentNeuronDispayReference->relativePosition.z = (double)(neuron->subnetID);
		}
	}

	currentNeuronDispayReference->name = SPRITE_SUBMODEL_NEURON_FILE_NAME;

	return result;
}

//currently this function just adds a plain line between neuron1 and neuron2, in the future it could be more complex
bool ANNfillNeuronConnectionDisplayReference(Reference * currentNeuronDispayReference, Reference * backNeuronReference, Reference * forwardNeuronReference, NeuronConnection * neuronConnection)
{
	bool result = true;

	//add neuron connection sprite info
	currentNeuronDispayReference->type = REFERENCE_TYPE_LINE;


	if(neuronConnection->weight < (-3.0))
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_MAGENTA;
	}
	else if(neuronConnection->weight < (-0.8))
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_RED;
	}
	else if(neuronConnection->weight < -0.4)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_ORANGE;
	}
	else if(neuronConnection->weight < -0.01)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_YELLOW;
	}
	else if(neuronConnection->weight < 0.01)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_DARKGREY;
	}
	else if(neuronConnection->weight < 0.4)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_GREEN;
	}
	else if(neuronConnection->weight < 0.8)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_CYAN;
	}
	else if(neuronConnection->weight < 3.0)
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_BLUE;
	}
	else
	{
		currentNeuronDispayReference->colour = DAT_FILE_COLOUR_PURPLE;
	}
	//currentNeuronDispayReference->colour = DAT_FILE_DEFAULT_COLOUR_EDGELINE;


	//else
	//{
	//	result = false;
	//	cout << "error: illegal neuron connection weight. neuronConnectionContainer->neuronConnection->weight = " << neuronConnectionContainer->neuronConnection->weight << endl;
	//}

	currentNeuronDispayReference->vertex1relativePosition = backNeuronReference->relativePosition;
	currentNeuronDispayReference->vertex2relativePosition = forwardNeuronReference->relativePosition;

	return result;
}





bool ANNdetermineSpriteInfoForNeuronConnectionAndAddSpriteToSpriteRefList(Reference * neuronReference, NeuronConnectionContainer * neuronConnectionContainer, Reference * spriteListInitialReference, vec * eyeCoords, int * numSpritesAdded, char * sceneFileName, Reference * backNeuronReference, Reference * forwardNeuronReference)
{
	bool result = true;

	//add sprite info [textual + range info] to reference list:
	Reference * spriteSubmodelInitialReference = new Reference();
	Reference * spriteSubmodelCurrentReference = spriteSubmodelInitialReference;

	//create textual sprite info:
	string * spriteTextString = new string();

	int spriteNumberOfLines;
	spriteNumberOfLines = SPRITE_TEXTUAL_MAX_NUM_OF_LINES;
	int * spriteColourArray = new int[spriteNumberOfLines];
	ANNgenerateTextualNeuronConnectionSpriteInfoString(neuronConnectionContainer, spriteTextString, spriteColourArray);
	spriteSubmodelCurrentReference = ANNaddTextualSpriteInfoStringToReferenceList(spriteTextString, spriteColourArray, spriteSubmodelCurrentReference, spriteNumberOfLines);
	delete spriteTextString;
	delete spriteColourArray;
	
	*numSpritesAdded = (*numSpritesAdded + 1);

		//cout << "here13" << endl;
	//CHECK THIS
	/*
	spriteSubmodelCurrentReference = addNeuronConnectionSpriteInfoToReferenceList(spriteSubmodelCurrentReference, neuronReference1, neuronReference2, neuronConnectionContainer);
	*numSpritesAdded = (*numSpritesAdded + 1);
	*/

	//generate sprite reference name
	char * spriteReferenceFileName = new char[DAT_FILE_REF_SUBMODEL_NAME_LENGTH_MAX];

	ANNcreateSpriteReferenceName(spriteReferenceFileName, *numSpritesAdded, sceneFileName);
	cout << "spriteReferenceFileName = " << spriteReferenceFileName << endl;

	//cout << "DEBUG unitBeingSprited = " << unitReference->name << endl;


#ifdef CPLUSPLUSERRORCORRECTION3
	char * CHICKENDEBUG = new char[DAT_FILE_REF_MAX_SIZE*DAT_FILE_MAX_NUM_OF_REFERENCES];
#endif

	//writeReferencesToFile
	if(!writeReferencesToFile(spriteReferenceFileName, spriteSubmodelInitialReference))
	{
		result = false;
	}
	
	delete spriteSubmodelInitialReference;

	int spriteDefaultColour = SPRITE_DEFAULT_COLOUR;

	//addSpriteReferenceToSpriteListByteArray
	//if(!ANNaddSpriteToSpriteReferenceList(&(neuronReference->absolutePosition), eyeCoords, spriteListInitialReference, spriteReferenceFileName, spriteDefaultColour))


	vec centralPositionOfConnection;
	centralPositionOfConnection.x = (backNeuronReference->relativePosition.x + forwardNeuronReference->relativePosition.x)/2.0;
	centralPositionOfConnection.y = (backNeuronReference->relativePosition.y + forwardNeuronReference->relativePosition.y)/2.0;
	centralPositionOfConnection.z = (backNeuronReference->relativePosition.z + forwardNeuronReference->relativePosition.z)/2.0;

	if(!ANNaddSpriteToSpriteReferenceList(&centralPositionOfConnection, eyeCoords, spriteListInitialReference, spriteReferenceFileName, spriteDefaultColour))
	{
		result = false;
	}
	
	delete spriteReferenceFileName;
	
	

	return result;
}


bool ANNdetermineSpriteInfoForNeuronAndAddSpriteToSpriteRefList(Reference * neuronReference, NeuronContainer * neuron, Reference * spriteListInitialReference, vec * eyeCoords, int * numSpritesAdded, char * sceneFileName)
{
	bool result = true;

	//add sprite info [textual + range info] to reference list:
	Reference * spriteSubmodelInitialReference = new Reference();
	Reference * spriteSubmodelCurrentReference = spriteSubmodelInitialReference;

	//create textual sprite info:
	string * spriteTextString = new string();

	int spriteNumberOfLines;
	spriteNumberOfLines = SPRITE_TEXTUAL_MAX_NUM_OF_LINES;
	int * spriteColourArray = new int[spriteNumberOfLines];
	ANNgenerateTextualNeuronSpriteInfoString(neuron, spriteTextString, spriteColourArray);
	spriteSubmodelCurrentReference = ANNaddTextualSpriteInfoStringToReferenceList(spriteTextString, spriteColourArray, spriteSubmodelCurrentReference, spriteNumberOfLines);

	*numSpritesAdded = (*numSpritesAdded + 1);

	delete spriteTextString;
	delete spriteColourArray;
	

	//CHECK THIS
	/*
		//cout << "here13" << endl;
	spriteSubmodelCurrentReference = addNeuronSpriteBiasInfoToReferenceList(spriteSubmodelCurrentReference, neuron);
	*numSpritesAdded = (*numSpritesAdded + 1);
	*/


	//generate sprite reference name
	char * spriteReferenceFileName = new char[DAT_FILE_REF_SUBMODEL_NAME_LENGTH_MAX];

	ANNcreateSpriteReferenceName(spriteReferenceFileName, *numSpritesAdded, sceneFileName);
	cout << "spriteReferenceFileName = " << spriteReferenceFileName << endl;

	//cout << "DEBUG unitBeingSprited = " << unitReference->name << endl;


#ifdef CPLUSPLUSERRORCORRECTION3
	char * CHICKENDEBUG = new char[DAT_FILE_REF_MAX_SIZE*DAT_FILE_MAX_NUM_OF_REFERENCES];
#endif

	//writeReferencesToFile
	if(!writeReferencesToFile(spriteReferenceFileName, spriteSubmodelInitialReference))
	{
		result = false;
	}

	delete spriteSubmodelInitialReference;
	
	int spriteDefaultColour = SPRITE_DEFAULT_COLOUR;

	//addSpriteReferenceToSpriteListByteArray
	//if(!ANNaddSpriteToSpriteReferenceList(&(neuronReference->absolutePosition), eyeCoords, spriteListInitialReference, spriteReferenceFileName, spriteDefaultColour))
	if(!ANNaddSpriteToSpriteReferenceList(&(neuronReference->relativePosition), eyeCoords, spriteListInitialReference, spriteReferenceFileName, spriteDefaultColour))
	{
		result = false;
	}

	delete spriteReferenceFileName;
	
	return result;
}


void ANNcreateSpriteReferenceName(char * spriteReferenceFileName, int spriteIndex, char * sceneFileName)
{
	//cout << "66" << endl;
	//creates sprite reference name spriteReferenceName = [SPRITE_NAME_START][spriteIndex][sceneFileName]
	char * tempString = new char[SPRITE_INDEX_MAGNITUDE*CPLUSPLUSERRORCORRECTION2];

	spriteReferenceFileName[0] = '\0';

	strcpy(tempString, sceneFileName);

	int i;
	for(i = 0; i < strlen(tempString); i++)
	{
		if(tempString[i] == '.')
		{
			tempString[i] = '\0';
		}
	}
	strcat(spriteReferenceFileName, tempString);

	strcat(spriteReferenceFileName, SPRITE_NAME_START.c_str());
	//itoa(spriteIndex, tempString, 10);
	sprintf(tempString, "%d", spriteIndex);

	strcat(spriteReferenceFileName, tempString);

	strcat(spriteReferenceFileName, SPRITE_EXTENSION.c_str());

	//cout << "67" << endl;
	delete tempString;
	//cout << "68" << endl;
	//create the "spritex.ldr" file that will be referenced by the scene file
}


//CHECK THIS spriteSubmodelCurrentReference parameter may have to be changed to the ANNaddTextualSpriteInfoStringToReferenceList() function return value
//bool ANNaddTextualSpriteInfoStringToReferenceList(string * spriteTextString, int spriteColourArray[], Reference * spriteSubmodelFirstReference, int spriteNumberOfLines, Reference * spriteSubmodelFinalReference);
Reference * ANNaddTextualSpriteInfoStringToReferenceList(string * spriteTextString, int spriteColourArray[], Reference * spriteSubmodelInitialReference, int spriteNumberOfLines)
{
	bool result = true;

	char * spriteText = new char[(*spriteTextString).size()+1];
	const char * constSpriteText = (*spriteTextString).c_str();
	strcpy(spriteText, constSpriteText);
	int spriteTextLength = (int)strlen(spriteText);

	int spriteTextIndex;

	Reference * spriteSubmodelCurrentReference = spriteSubmodelInitialReference;

	vec spriteSubmodelCurrentReferencePosition;
	spriteSubmodelCurrentReferencePosition.x = 0.0 - (SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS / 2);
	spriteSubmodelCurrentReferencePosition.y = 0.0 + SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS;
	spriteSubmodelCurrentReferencePosition.z = 0.0;


	//common local variables for loop
	double spriteCurrentCharacterSpacing;
	int spriteLineNumber = 0;

	for(spriteTextIndex = 0; spriteTextIndex < spriteTextLength; spriteTextIndex++)
	{
		/*convert lowercase text to uppercase text:*/
		if((spriteText[spriteTextIndex] >= 'a') && (spriteText[spriteTextIndex] <= 'z'))
		{
			spriteText[spriteTextIndex] = spriteText[spriteTextIndex] - ANSI_DECIMAL_DIFF_BETWEEN_CASE_TEXT;
		}

		if(spriteText[spriteTextIndex] == '\n')
		{
			spriteLineNumber++;
			if(spriteLineNumber >= spriteNumberOfLines)
			{
				cout << "error; (spriteLineNumber >= spriteNumberOfLines)" << endl;
				cout << "spriteLineNumber = " << spriteLineNumber << endl;
				cout << "spriteNumberOfLines = " << spriteNumberOfLines << endl;
				result = false;
			}
			spriteSubmodelCurrentReferencePosition.y  = spriteSubmodelCurrentReferencePosition.y + SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS;
			spriteSubmodelCurrentReferencePosition.x = 0.0 - (SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS / 2);
		}
		else if(((spriteText[spriteTextIndex] >= '0') && (spriteText[spriteTextIndex] <= '9')) || (spriteText[spriteTextIndex] == CHAR_PLUS) || (spriteText[spriteTextIndex] == CHAR_MINUS) || (spriteText[spriteTextIndex] == CHAR_EQUALS) || (spriteText[spriteTextIndex] == CHAR_FULLSTOP))
		{
			spriteCurrentCharacterSpacing = SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS; 	//OLD; SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS * (SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS/SPRITE_CHAR_WIDTH_IN_PIXELS);
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing/2;
			ANNspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &spriteSubmodelCurrentReferencePosition, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing;
			Reference * newReference = new Reference();
			spriteSubmodelCurrentReference -> next = newReference;
			spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;
		}
		else if((spriteText[spriteTextIndex] >= 'A') && (spriteText[spriteTextIndex] <= 'Z'))
		{
			spriteCurrentCharacterSpacing = SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS;
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing/2;
			ANNspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &spriteSubmodelCurrentReferencePosition, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing/2;
			Reference * newReference = new Reference();
			spriteSubmodelCurrentReference -> next = newReference;
			spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;
		}
		else if(((unsigned char)spriteText[spriteTextIndex] > (unsigned char)SPRITE_CHARACTER_DICE_OFFSET) && ((unsigned char)spriteText[spriteTextIndex] <= (unsigned char)(SPRITE_CHARACTER_DICE_OFFSET+MAX_ATTACK_DEFENCE_LEVEL)))
		{
			spriteCurrentCharacterSpacing = SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS;
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing/2;
			ANNspriteSubmodelFillTextualReference(spriteSubmodelCurrentReference, &spriteSubmodelCurrentReferencePosition, spriteText[spriteTextIndex], spriteColourArray[spriteLineNumber]);
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + spriteCurrentCharacterSpacing;
			Reference * newReference = new Reference();
			spriteSubmodelCurrentReference -> next = newReference;
			spriteSubmodelCurrentReference = spriteSubmodelCurrentReference -> next;
		}
		else if(spriteText[spriteTextIndex] == ' ')
		{
			spriteSubmodelCurrentReferencePosition.x = spriteSubmodelCurrentReferencePosition.x + (SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS/2);
		}
		else
		{
			char temp = (char)SPRITE_CHARACTER_DICE_OFFSET;
			char temp2 = (char)(SPRITE_CHARACTER_DICE_OFFSET+MAX_ATTACK_DEFENCE_LEVEL);
			printf("\nunknown character - system must exit (character = %c %d)", spriteText[spriteTextIndex], spriteText[spriteTextIndex]);
			printf("\nNB SPRITE_CHARACTER_DICE_OFFSET = %c %d", temp, temp);
			printf("\nNB (SPRITE_CHARACTER_DICE_OFFSET+MAX_ATTACK_DEFENCE_LEVEL) = %c %d", temp2, temp2);
			exit(0);
		}
	}

	delete spriteText;

	//spriteSubmodelFinalReference = spriteSubmodelCurrentReference;

	return spriteSubmodelCurrentReference;
}




/*primary sprite routines*/

//OLD: new items [eg char, Reference] are currently not being properly created in LRRCsprite.cpp
bool ANNaddSpriteToSpriteReferenceList(vec * spriteSceneCoords, vec * eyeCoords, Reference * spriteListInitialReference, char * spriteReferenceFileName, int spriteDefaultColour)
{
	//add sprite to spriteByteArray (replace sprite of sprite index, spriteIndex, if it already exists)

	bool result = true;


	//spriteReferenceSubmodelNameLength = (int)strlen(spriteReferenceFileName);

	Reference * spriteReference = new Reference();

	spriteReference->colour = spriteDefaultColour;		//CHECK THIS - this should be changed to player
	spriteReference->type = REFERENCE_TYPE_SUBMODEL;
	mat spriteRotationMatrix;

	createIdentityMatrix(&spriteRotationMatrix);

	createIdentityMatrix(&spriteRotationMatrix);
	scaleMatrix(&spriteRotationMatrix, (0.00008*(SPRITE_SUBMODEL_RANGE_SCALE_FACTOR*LDRAW_UNITS_PER_CM)));		//	scaleMatrix(&currentDeformationMatrix, ((neuronContainer->neuron->bias)*(SPRITE_SUBMODEL_RANGE_SCALE_FACTOR*LDRAW_UNITS_PER_CM)));

/*original before RBB 26-jan-07
	ANNgenerateSpriteRotationMatrix(spriteSceneCoords, eyeCoords, &spriteRotationMatrix);
*/
	copyMatrix2IntoMatrix1(&(spriteReference->deformationMatrix), &(spriteRotationMatrix));
		//spriteReference->deformationMatrix = spriteRotationMatrix;

	spriteReference->relativePosition.x = spriteSceneCoords->x;
	spriteReference->relativePosition.y = spriteSceneCoords->y;
	spriteReference->relativePosition.z = spriteSceneCoords->z;
	spriteReference->name = spriteReferenceFileName;
	//cout << "DEBUG: mmstart";


	int lineNumberInFileOfSprite;

	/*
	cout << "about to findTextInByteArray;" << endl;
	cout << "DEBUG: spriteListByteArray = " << spriteListByteArray << endl;
	cout << "DEBUG: *spriteListByteArraySize = " << *spriteListByteArraySize << endl;
	cout << "DEBUG: spriteReferenceString = " << spriteReferenceString << endl;
	cout << "DEBUG: spriteReferenceStringSize = " << spriteReferenceStringSize << endl;
	cout << "DEBUG: &lineNumberInFileOfSprite = " << &lineNumberInFileOfSprite << endl;
	*/

	if(search1DRefListNameAndColourFindRef(spriteListInitialReference, spriteReference))
	{
		//cout << "DEBUG LRRCsprite.cpp 3b " << endl;

		if(!search1DRefListNameAndColourReplaceRef(spriteListInitialReference, spriteReference, spriteReference))
		{
			cout << "error: cannot replace Reference in Sprite Reference List" << endl;
			cout << "\t spriteReference->colour  = \n" << spriteReference->colour  << endl;
			cout << "\t spriteReference->name = " << spriteReference->name << endl;
			result = false;
		}
	}
	else
	{
		//cout << "DEBUG LRRCsprite.cpp 3c " << endl;
		if(!search1DRefListAddReference(spriteListInitialReference, spriteReference))
		{
			cout << "error: cannot add Reference to Sprite Reference List" << endl;
			cout << "\t spriteReference->colour  = \n" << spriteReference->colour  << endl;
			cout << "\t spriteReference->name = " << spriteReference->name << endl;
			result = false;
		}
	}

	delete spriteReference;
	//cout << "DEBUG LRRCsprite.cpp 4 " << endl;

	return result;
}

void ANNgenerateTextualNeuronSpriteInfoString(NeuronContainer * neuronContainer, string * spriteTextString, int spriteColourArray[])
{
	/*Start Sprite Text Creation*/

	spriteColourArray[0] = SPRITE_TEXTUAL_INCLUDE_NEURON_ID_COLOUR;
	spriteColourArray[1] = SPRITE_TEXTUAL_INCLUDE_NEURON_ORDERID_COLOUR;
	spriteColourArray[2] = SPRITE_TEXTUAL_INCLUDE_NEURON_LAYERID_COLOUR;
	spriteColourArray[3] = SPRITE_TEXTUAL_INCLUDE_NEURON_SUBNETID_COLOUR;
	spriteColourArray[4] = SPRITE_TEXTUAL_INCLUDE_NEURON_BIAS_COLOUR;
	spriteColourArray[5] = SPRITE_TEXTUAL_INCLUDE_NEURON_OUTPUT_COLOUR;
	spriteColourArray[6] = SPRITE_TEXTUAL_INCLUDE_NEURON_CLASSTARGET_COLOUR;
	spriteColourArray[7] = SPRITE_TEXTUAL_INCLUDE_NEURON_ERROR_COLOUR;


	char * tempString = new char[DAT_FILE_DATA_VALUE_MAX_LENGTH*CPLUSPLUSERRORCORRECTION1];		//for some reason tempString must be very large or else the heap will get corrupted
	//char * tempString = new char[DAT_FILE_DATA_VALUE_MAX_LENGTH];

	/*Unit Name Information*/

	if(SPRITE_TEXTUAL_INCLUDE_NEURON_ID_INFO)
	{
		tempString[0] = '\0';
		sprintf(tempString, "%d", neuronContainer->neuron->id);
		if(SPRITE_TEXTUAL_INCLUDE_NEURON_EXTRA_SECONDARY_INFO)
		{
			*spriteTextString = *spriteTextString + "ID = " + tempString;
		}
		else
		{
			*spriteTextString = *spriteTextString + "        " + tempString;
		}
	}


	if(SPRITE_TEXTUAL_INCLUDE_NEURON_ORDERID_INFO)
	{
		*spriteTextString = *spriteTextString + '\n';
		tempString[0] = '\0';
		sprintf(tempString, "%d", neuronContainer->neuron->orderID);
		*spriteTextString = *spriteTextString + "orderID = " + tempString;
	}


	if(SPRITE_TEXTUAL_INCLUDE_NEURON_LAYERID_INFO)
	{
		*spriteTextString = *spriteTextString + '\n';
		tempString[0] = '\0';
		sprintf(tempString, "%d", neuronContainer->neuron->layerID);
		*spriteTextString = *spriteTextString + "layerID = " + tempString;
	}


	if(SPRITE_TEXTUAL_INCLUDE_NEURON_SUBNETID_INFO)
	{
		*spriteTextString = *spriteTextString + '\n';
		tempString[0] = '\0';
		sprintf(tempString, "%d", neuronContainer->neuron->subnetID);
		*spriteTextString = *spriteTextString + "subnetID = " + tempString;
	}


	if(SPRITE_TEXTUAL_INCLUDE_NEURON_BIAS_INFO)
	{
		*spriteTextString = *spriteTextString + '\n';
		tempString[0] = '\0';
		sprintf(tempString, "%0.2f", neuronContainer->neuron->bias);
		*spriteTextString = *spriteTextString + "bias = " + tempString;
	}


	if(SPRITE_TEXTUAL_INCLUDE_NEURON_OUTPUT_INFO)
	{
		*spriteTextString = *spriteTextString + '\n';
		tempString[0] = '\0';
		sprintf(tempString, "%0.2f", neuronContainer->neuron->output);
		*spriteTextString = *spriteTextString + "output = " + tempString;
	}

	if(SPRITE_TEXTUAL_INCLUDE_NEURON_CLASSTARGET_INFO)
	{
		*spriteTextString = *spriteTextString + '\n';
		tempString[0] = '\0';
		sprintf(tempString, "%0.2f", neuronContainer->neuron->classTarget);
		*spriteTextString = *spriteTextString + "classTarget = " + tempString;
	}

	if(SPRITE_TEXTUAL_INCLUDE_NEURON_ERROR_INFO)
	{
		*spriteTextString = *spriteTextString + '\n';
		tempString[0] = '\0';
		sprintf(tempString, "%0.2f", neuronContainer->neuron->error);
		*spriteTextString = *spriteTextString + "error = " + tempString;
	}

	//cout << "DEBUG 1l" << endl;

	delete tempString;

	//cout << "DEBUG: *spriteTextString = \n" << *spriteTextString << "\n\n" << endl;
	/*End Start Sprite Text Creation*/
}


void ANNgenerateTextualNeuronConnectionSpriteInfoString(NeuronConnectionContainer * neuronConnectionContainer, string * spriteTextString, int spriteColourArray[])
{
	/*Start Sprite Text Creation*/

	spriteColourArray[0] = SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_COLOUR;
	spriteColourArray[1] = SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_COLOUR;
	spriteColourArray[2] = SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_COLOUR;
	spriteColourArray[3] = SPRITE_TEXTUAL_INCLUDE_NEURONCONNECTION_WEIGHT_COLOUR;

	char * tempString = new char[DAT_FILE_DATA_VALUE_MAX_LENGTH*CPLUSPLUSERRORCORRECTION1];		//for some reason tempString must be very large or else the heap will get corrupted
	//char * tempString = new char[DAT_FILE_DATA_VALUE_MAX_LENGTH];

	/*Unit Name Information*/

	tempString[0] = '\0';
	sprintf(tempString, "%0.2f", neuronConnectionContainer->neuronConnection->weight);
	*spriteTextString = "\n\n" + *spriteTextString + "w = " + tempString;



	//cout << "DEBUG 1l" << endl;

	delete tempString;

	//cout << "DEBUG: *spriteTextString = \n" << *spriteTextString << "\n\n" << endl;
	/*End Start Sprite Text Creation*/
}




//OLD:
bool ANNaddSpriteListByteArrayToSceneFileInefficient(char * sceneFileName, char * sceneFileNameWithSprites, char * spriteListByteArray, int spriteListByteArraySize, int spriteListByteArrayLines)
{
	bool result = true;

	char * spriteHeaderSearchString = ANN_SPRITE_HEADER_NAME;
	char * spriteTrailerSearchString = ANN_SPRITE_TRAILER_NAME;
	int spriteHeaderSearchStringLength = ANN_SPRITE_HEADER_LENGTH;
	int spriteTrailerSearchStringLength = ANN_SPRITE_TRAILER_LENGTH;

	int sceneFileNumberOfLines;
	int sceneFileByteArraySize = 0;
	char * sceneFileByteArray = new char[DAT_FILE_MAX_NUM_OF_REFERENCES*DAT_FILE_REF_MAX_SIZE];

	if(!readFileIntoByteArray(sceneFileName, sceneFileByteArray, &sceneFileNumberOfLines, &sceneFileByteArraySize))
	{
		cout << "error: cannot read file, " << sceneFileName << endl;
		result = false;
	}
	else
	{
		//TEMP DEBUG
		/*
		int temp1 = DAT_FILE_MAX_NUM_OF_REFERENCES;
		int temp2 = DAT_FILE_REF_MAX_SIZE;
		cout << "DAT_FILE_MAX_NUM_OF_REFERENCES = " << temp1 << endl;
		cout << "DAT_FILE_REF_MAX_SIZE = " << temp2 << endl;
		*/

		#ifdef TEMPDEBUG
		cout << "DEBUG; sceneFileByteArray = \n" << endl;
		for(int i = 0; i < sceneFileByteArraySize; i++)
		{
			cout << sceneFileByteArray[i];
		}
		cout << "DEBUG; sceneFileNumberOfLines = " << sceneFileNumberOfLines << endl;
		cout << "DEBUG; sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
		#endif

		/*Start Sprite Header Section Confirmation*/

		int lineNumberOfSpriteHeader;
		int lineNumberOfSpriteTrailer;
		int lineNumberInFileOfSprite;

		bool spriteHeaderFound = false;
		bool spriteTrailerFound = false;

		/*determines whether a Sprite Header line exists in the scene file by looking for a spriteHeaderSearchString*/
		if(findTextInByteArray(sceneFileByteArray, sceneFileByteArraySize, spriteHeaderSearchString, spriteHeaderSearchStringLength, &lineNumberOfSpriteHeader))
		{
			spriteHeaderFound = true;
		}

		/*determines whether a Sprite Trailer line exists in the scene file by looking for a spriteHeaderSearchString*/
		if(findTextInByteArray(sceneFileByteArray, sceneFileByteArraySize, spriteTrailerSearchString, spriteTrailerSearchStringLength, &lineNumberOfSpriteTrailer))
		{
			spriteTrailerFound = true;
		}
		/*End Sprite Header Section Confirmation*/

		if(spriteHeaderFound && spriteTrailerFound)
		{
			/*sprite header info found, continue*/
			lineNumberInFileOfSprite = (lineNumberOfSpriteHeader+1);
			if(!replaceLinesInByteArray(sceneFileByteArray, spriteListByteArray, &sceneFileByteArraySize, spriteListByteArraySize, lineNumberInFileOfSprite, (lineNumberOfSpriteTrailer - lineNumberOfSpriteHeader - 1)))
			{
				cout << "error: cannot replace line in byte array" << endl;
				cout << "\t sceneFileNumberOfLines = \n" << sceneFileNumberOfLines << endl;
				cout << "\t sceneFileByteArray = \n" << sceneFileByteArray << endl;
				cout << "\t spriteListByteArray = \n" << spriteListByteArray << endl;
				cout << "\t sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
				cout << "\t spriteListByteArraySize = " << spriteListByteArraySize << endl;
				cout << "\t lineNumberInFileOfSprite = " << lineNumberInFileOfSprite << endl;
				cout << "\t numLinesToReplace = " << (lineNumberOfSpriteTrailer - lineNumberOfSpriteHeader - 1) << endl;
				result = false;
			}

			//write the byteArray - replacing the original scene file
			writeByteArrayToFile(sceneFileNameWithSprites, sceneFileByteArray, sceneFileByteArraySize);
		}
		else if(!spriteHeaderFound && !spriteTrailerFound)
		{
			/*add a sprite header to scene file*/
			#ifdef TEMPDEBUG
			cout << "\n\n ADDING SPRITE HEADER TO SCENE FILE \n\n" << endl;
			#endif

			lineNumberOfSpriteHeader = (sceneFileNumberOfLines-1);

			#ifdef TEMPDEBUG2
			cout << "DEBUG; sceneFileByteArraySize theoretical = " << (sceneFileByteArraySize + ANN_SPRITE_HEADER_LENGTH) << endl;
			#endif

			if(!addLinesToByteArray(sceneFileByteArray, spriteHeaderSearchString, &sceneFileByteArraySize, spriteHeaderSearchStringLength, lineNumberOfSpriteHeader))
			{
				cout << "error: cannot add line to byte array" << endl;
				cout << "\t sceneFileNumberOfLines = \n" << sceneFileNumberOfLines << endl;
				//cout << "\t sceneFileByteArray = \n" << sceneFileByteArray << endl;
				cout << "\t spriteHeaderSearchString = " << spriteHeaderSearchString << endl;
				cout << "\t sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
				cout << "\t spriteHeaderSearchStringLength = " << spriteHeaderSearchStringLength << endl;
				cout << "\t lineNumberOfSpriteHeader = " << lineNumberOfSpriteHeader << endl;
				result = false;
			}

			sceneFileNumberOfLines=sceneFileNumberOfLines+ANN_SPRITE_HEADER_NUM_LINES;

			#ifdef TEMPDEBUG2
			cout << "DEBUG; sceneFileByteArray = \n" << endl;
			for(int i = 0; i < sceneFileByteArraySize; i++)
			{
				cout << sceneFileByteArray[i];
			}
			cout << "DEBUG; sceneFileNumberOfLines = " << sceneFileNumberOfLines << endl;
			cout << "DEBUG; sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
			#endif

			/*add a sprites to scene file*/
			#ifdef TEMPDEBUG
			cout << "\n\n ADDING SPRITES TO SCENE FILE  \n\n" << endl;
			#endif

			#ifdef TEMPDEBUG2
			cout << "DEBUG; sceneFileByteArraySize theoretical = " << (sceneFileByteArraySize + spriteListByteArraySize) << endl;
			#endif

			lineNumberInFileOfSprite = (sceneFileNumberOfLines-1);
			if(!addLinesToByteArray(sceneFileByteArray, spriteListByteArray, &sceneFileByteArraySize, spriteListByteArraySize, lineNumberInFileOfSprite))
			{
				cout << "error: cannot add line to byte array" << endl;
				cout << "\t sceneFileNumberOfLines = \n" << sceneFileNumberOfLines << endl;
				//cout << "\t sceneFileByteArray = \n" << sceneFileByteArray << endl;
				cout << "\t spriteListByteArray = \n" << spriteListByteArray << endl;
				cout << "\t sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
				cout << "\t spriteListByteArraySize = " << spriteListByteArraySize << endl;
				cout << "\t lineNumberInFileOfSprite = " << lineNumberInFileOfSprite << endl;
				result = false;
			}
			sceneFileNumberOfLines = sceneFileNumberOfLines + spriteListByteArrayLines;


			#ifdef TEMPDEBUG2
			cout << "DEBUG; sceneFileByteArray = \n" << endl;
			for(int i = 0; i < sceneFileByteArraySize; i++)
			{
				cout << sceneFileByteArray[i];
			}
			cout << "DEBUG; sceneFileNumberOfLines = " << sceneFileNumberOfLines << endl;
			cout << "DEBUG; sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
			#endif


			/*add a sprite trailer to scene file*/
			#ifdef TEMPDEBUG
			cout << "\n\n ADDING SPRITE TRAILER TO SCENE FILE  \n\n" << endl;
			#endif

			lineNumberOfSpriteTrailer = (sceneFileNumberOfLines-1);
			if(!addLinesToByteArray(sceneFileByteArray, spriteTrailerSearchString, &sceneFileByteArraySize, spriteTrailerSearchStringLength, lineNumberOfSpriteTrailer))
			{
				cout << "error: cannot add line to byte array" << endl;
				cout << "\t sceneFileNumberOfLines = \n" << sceneFileNumberOfLines << endl;
				//cout << "\t sceneFileByteArray = \n" << sceneFileByteArray << endl;
				cout << "\t spriteTrailerSearchString = " << spriteTrailerSearchString << endl;
				cout << "\t sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
				cout << "\t spriteTrailerSearchStringLength = " << spriteTrailerSearchStringLength << endl;
				cout << "\t lineNumberOfSpriteTrailer = " << lineNumberOfSpriteTrailer << endl;
				result = false;
			}
			sceneFileNumberOfLines=sceneFileNumberOfLines+ANN_SPRITE_TRAILER_NUM_LINES;


			#ifdef TEMPDEBUG
			cout << "DEBUG; sceneFileByteArray = \n" << endl;
			for(int i = 0; i < sceneFileByteArraySize; i++)
			{
				cout << sceneFileByteArray[i];
			}
			cout << "DEBUG; sceneFileNumberOfLines = " << sceneFileNumberOfLines << endl;
			cout << "DEBUG; sceneFileByteArraySize = " << sceneFileByteArraySize << endl;
			#endif


			//write the byteArray - replacing the original scene file
			writeByteArrayToFile(sceneFileNameWithSprites, sceneFileByteArray, sceneFileByteArraySize);
		}
		else
		{
			result = false;
			cout << "error: file contains inconsistent sprite header/trailer, spriteHeaderFound = " << spriteHeaderFound << ", spriteTrailerFound = " << spriteTrailerFound << endl;
		}
	}

	delete sceneFileByteArray;

	return result;
}

/*this is not complete yet - just use an Identity matrix - ie do not rotate the sprite according to the user POV*/
void ANNgenerateSpriteRotationMatrix(vec * spriteSceneCoords, vec * eyeCoords, mat * spriteRotationMatrix)
{
	//TEMP - this is not complete
	createIdentityMatrix(spriteRotationMatrix);		//CHECK THIS
}


void ANNspriteSubmodelFillTextualReference(Reference * spriteSubmodelCurrentReference, vec * spriteParagraphCurrentPosition, char characterToWrite, int spriteColour)
{
	string referenceNameStart = SPRITE_CHARACTER_START;
	string referenceNameEnd = SPRITE_CHARACTER_EXTENSION;
	spriteSubmodelCurrentReference->colour = spriteColour;
	spriteSubmodelCurrentReference->type = REFERENCE_TYPE_SUBMODEL;

	spriteSubmodelCurrentReference->relativePosition.x = spriteParagraphCurrentPosition->x;
	spriteSubmodelCurrentReference->relativePosition.y = spriteParagraphCurrentPosition->y;
	spriteSubmodelCurrentReference->relativePosition.z = spriteParagraphCurrentPosition->z;

	mat currentDeformationMatrix;

	char * tempString = new char[SPRITE_INDEX_MAGNITUDE];

	if(((unsigned char)characterToWrite > (unsigned char)SPRITE_CHARACTER_DICE_OFFSET) && ((unsigned char)characterToWrite <= (unsigned char)(SPRITE_CHARACTER_DICE_OFFSET+MAX_ATTACK_DEFENCE_LEVEL)))
	{
		/*no change to currentDeformationMatrix*/
		createIdentityMatrix(&currentDeformationMatrix);

		scaleMatrix(&currentDeformationMatrix, SPRITE_TEXT_DICE_SCALE_FACTOR);
		spriteSubmodelCurrentReference->relativePosition.y = spriteSubmodelCurrentReference->relativePosition.y + SPRITE_TEXT_DICE_Y_OFFSET;
		spriteSubmodelCurrentReference->colour = spriteSubmodelCurrentReference->colour + DAT_FILE_COLOUR_TRANPARENT_MOD;
		tempString[0] = 'd';
		int diceValue = ((unsigned char)characterToWrite - (unsigned char)SPRITE_CHARACTER_DICE_OFFSET)*2;
		if(diceValue > 9)
		{
			tempString[1] = 1 + SPRITE_CHARACTER_NUM_OFFSET;
			tempString[2] = (diceValue - 10) + SPRITE_CHARACTER_NUM_OFFSET;
			tempString[3] = '\0';
		}
		else
		{
			tempString[1] = (diceValue + SPRITE_CHARACTER_NUM_OFFSET);
			tempString[2] = '\0';
		}

	}
	else
	{
		createIdentityMatrix(&currentDeformationMatrix);
		scaleMatrix(&currentDeformationMatrix, SPRITE_TEXT_SCALE_FACTOR);
		tempString[0] = characterToWrite;
		tempString[1] = '\0';
	}

	copyMatrix2IntoMatrix1(&(spriteSubmodelCurrentReference->deformationMatrix), &(currentDeformationMatrix));

	spriteSubmodelCurrentReference->name = referenceNameStart + tempString + referenceNameEnd;
	//cout << "DEBUG: spriteSubmodelCurrentReference->name = " << spriteSubmodelCurrentReference->name << endl;

	delete tempString;
}






