/*******************************************************************************
 *
 * File Name: LDvector.h
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 1l3j 2-Sept-08
 *
 *******************************************************************************/


#ifndef HEADER_LD_VECTOR
#define HEADER_LD_VECTOR

#include "LDreferenceClass.h"

#define PI (3.1416)

bool compareDoubles(double a, double b);
bool compareVectors(vec * veca, vec * vecb);
bool compareMatricies(mat * mata, mat * matb);
void copyVectors(vec * vecNew, vec * vecbToCopy);
void copyMatricies(mat * matNew, mat * matToCopy);
void multiplyMatricies(mat * matNew, mat * mat1, mat * mat2);

void subtractVectors(vec * vecNew, vec * a, vec * b);
void addVectors(vec * vecNew, vec * a, vec * b);

void multiplyVectorByScalar(vec * vec, double scalar);

double calculateTheDistanceBetweenTwoPoints(vec * positionOfUnit1, vec * positionOfUnit2);
double calculateTheDistanceBetweenTwoPoints(double positionXOfUnit1, double positionXOfUnit2, double positionYOfUnit1, double positionYOfUnit2, double positionZOfUnit1, double positionZOfUnit2);



void createRotationxMatrix(mat* matrix, double rotation);
void createRotationyMatrix(mat* matrix, double rotation);
void createRotationzMatrix(mat* matrix, double rotation);
double convertDegreesToRadian(double degrees);
//void rotateMatrix(mat * matrix, char rotationAxis, double rotationDegrees);
void createIdentityMatrix(mat* matx);
void copyMatrix2IntoMatrix1(mat* mat1, mat* mat2);
void scaleMatrix(mat * matrix, double scaleFactor);
void createRotatationMatrix(mat * matrix, char rotationAxis, double rotationDegrees);

#endif




