/*******************************************************************************
 *
 * File Name: LRRCunitClass.cpp
 * Author: Richard Baxter
 * Project: Lego Rules CG Rounds Checker
 * Project Version: 1l3j 2-Sept-08
 * Project First Internal Release: 1aXx 18-Sept-05 (C)
 * Project Second Internal Release: 2aXx 02-April-06 (convert to C++)
 * Project Third Internal Release: 2b7d 26-Sept-06 (added sprites)
 * Project Fourth Internal Release: 2c4a 25-Feb-07 [rotation of models supported, copyCombatRelevantInheritedImmediateParentUnitDetailsIntoChildObject() no longer used]
 * Project Fifth Internal Release: 2d11a 3-June-07
 *
 * NB phase specific sprites are yet to be added to scene files based upon movement/combat outcomes
 * NB phase specific sprites are yet to be added to scene files based upon future movement/combat options
 *******************************************************************************/

#ifndef HEADER_LRRC_UNIT_CLASS
#define HEADER_LRRC_UNIT_CLASS

#include "LDglobalDefs.h"
//#assert USE_ANN

#include "ANNexperienceClass.h"
#include "LRRCmodelClass.h"

#include <string>
#include <iostream>
#include <fstream>
#include <time.h>
#include <math.h>
using namespace std;



#define GAME_INDEX_OF_PROPERTIES_EXPERIENCE_NN (0)
#define GAME_INDEX_OF_COMBAT_EXPERIENCE_NN (1)
#define GAME_INDEX_OF_GLOBAL_EXPERIENCE_NN (2)
#define GAME_NUMBER_OF_EXPERIENCE_NN (3)
#define GAME_INDEX_OF_ALL_EXPERIENCES_NN (GAME_NUMBER_OF_EXPERIENCE_NN)

class UnitListClass
{
private:
	/*There are currently no private attributes of this class*/
public:

	UnitListClass(void); // constructor
	~UnitListClass();	// and destructor.

	int number;
	bool status;	//alive/dead
	int roundSpawned;
	int roundRemoved;
	int numKills;
	int killPoints;

	/*temporary per player turn variables*/
	bool hasPerformedAction[GAME_PHASES_NUM_PER_TURN];

	string name;	//currently used identifier of the unit in game scene files
	int team;		//not currently used, as there is 1 UnitListClass created for every team
	//long id;		//the unique id/number for every unit - not currently used
	ModelDetails * unitDetails;

	Experience * firstExperience[GAME_NUMBER_OF_EXPERIENCE_NN];
	Experience * currentExperience[GAME_NUMBER_OF_EXPERIENCE_NN];		//temp variable for experience linked list creation

	bool isUnitGroup;
	UnitListClass * firstUnitInUnitGroup;

	double selfLearningTempVarBackPropagationPassError[GAME_NUMBER_OF_EXPERIENCE_NN];	//temp variable used for determination of whether to use this unit for a certain game action (Eg Combat)
	bool selfLearningTempVarUnitHasBeenTried;
	bool selfLearningTempVarUnitPrefersLongDistanceCombatToMovement;
	
	UnitListClass * next;

};

UnitListClass * searchUnitListFindOpponentWithLowestError(int currentPlayerTurn, int currentPhase, UnitListClass * firstUnitInUnitGroup, double * currentLowestError, bool * foundOpponent);

UnitListClass * searchUnitListFindUnit(UnitListClass * firstUnitInUnitList, string unitName, int unitColour, bool * unitIDFound);

void addUnitToList(UnitListClass * firstUnitInUnitList, string unitName, int unitColour, ModelDetails * unitDetails, int currentRound);
bool splitUnitGroup(UnitListClass * firstUnitInUnitList, string unitGroupName, int unitGroupColour, int currentRound);

void searchUnitListAssignHasNotPerformedAction(UnitListClass * firstUnitInUnitGroup);


#endif




