/*******************************************************************************
 *
 * File Name: LRRCTHgame.h
 * Author: Richard Baxter
 * Project: Lego Rules CG Rounds Checker
 * Project Version: 1l3j 2-Sept-08
 * Project First Internal Release: 1aXx 18-Sept-05 (C)
 * Project Second Internal Release: 2aXx 02-April-06 (convert to C++)
 * Project Third Internal Release: 2b7d 26-Sept-06 (added sprites)
 * Project Fourth Internal Release: 2c4a 25-Feb-07 [rotation of models supported, copyCombatRelevantInheritedImmediateParentUnitDetailsIntoChildObject() no longer used]
 * Project Fifth Internal Release: 2d11a 3-June-07
 *
 *******************************************************************************/



#ifndef HEADER_TH_LRRC_GAME
#define HEADER_TH_LRRC_GAME

#include "LRRCplayerClass.h"
#include "LDglobalDefs.h"

#define TH_LRRC_GAME_NUMBER_OF_UNITS_TO_FEED (100)
#define TH_LRRC_GAME_NUMBER_OF_NN_LAYERS (5)		//default = 5
//#define HEAPS_OF_RAM
 

bool cullUnitList(UnitListClass * firstUnitInUnitList, int numberOfUnitsRequired);
bool randomiseUnitList(UnitListClass * firstUnitInNonRandomisedUnitList, UnitListClass * firstUnitInUnitList, long numberOfUnits);
int THtestANNusingCombatExperiences();
long THgenerateUnitListwithAllUnitProperties(UnitListClass * firstUnitInUnitList);
bool generateUnitDetails(ModelDetails * unitDetails, int selectionUnitTypeCatagories, int selectionUnitCombatDetailsAttackCloseCombat, int selectionUnitCombatDetailsAttackLongDistance, int selectionUnitCombatDetailsDefenceHead, int selectionUnitCombatDetailsDefenceTorso, int selectionUnitCombatDetailsDefenceShield);
bool THperformGenericCombatWithAllPermutationsOfUnitsInListAndAddExperiences(int currentPhase, UnitListClass * firstUnitInUnitList, Player * currentPlayer, int NNBeingTested);
double THperformGenericCombatWithAllPermutationsOfUnitsInListAndCompareExperiencesWithNN(int currentPhase, UnitListClass * firstUnitInUnitList, Player * currentPlayer, int NNBeingTested);
bool THperformGenericCombatWithTwoCombatReadyUnitsAndAddExperience(int currentPhase, UnitListClass * unitAttacker, UnitListClass * unitDefender, Player * currentPlayer, int NNBeingTested);
double THperformGenericCombatWithTwoCombatReadyUnitsAndCompareExperienceWithNN(int currentPhase, UnitListClass * unitAttacker, UnitListClass * unitDefender, Player * currentPlayer, int NNBeingTested);
bool THaddExperienceFromUnitPropertiesDecision(UnitListClass * unit, UnitListClass * unitOpponent, long unitDecision, Player * currentPlayer);
bool THaddExperienceFromUnitCombatDecision(UnitListClass * unit, UnitListClass * unitOpponent, long unitDecision, Player * currentPlayer);
double THcompareExperienceFromUnitPropertiesDecisionWithNN(UnitListClass * unit, UnitListClass * unitOpponent, long unitDecision, Player * currentPlayer);
double THcompareExperienceFromUnitCombatDecisionWithNN(UnitListClass * unit, UnitListClass * unitOpponent, long unitDecision, Player * currentPlayer);

#endif


